package com.datacloudsec.utils;

import com.datacloudsec.exception.UEException;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;

public class HttpUtil {

   public static String requestByData(String url, String reqHeader, String reqBody, String charset) throws Exception {
      String[] firstLine = null;
      String[] properties = null;
      if(reqHeader != null) {
         properties = reqHeader.split("\r|\n");
         if(properties.length > 0) {
            firstLine = properties[0].replaceAll("[\\s]{2,}", " ").split(" ");
         }
      }

      if(firstLine != null && firstLine.length != 0) {
         URL oldUrl = new URL(url);
         StringBuffer newAddr = new StringBuffer();
         newAddr.append(oldUrl.getProtocol());
         newAddr.append("://");
         newAddr.append(oldUrl.getHost());
         newAddr.append(":");
         newAddr.append(oldUrl.getPort());
         if(firstLine.length >= 3) {
            newAddr.append(firstLine[1]);
         }

         HttpURLConnection connection = (HttpURLConnection)(new URL(newAddr.toString())).openConnection();
         OutputStream os = null;

         String var18;
         try {
            connection.setConnectTimeout(14000);
            connection.setReadTimeout(14000);
            connection.setDoInput(true);
            connection.setDoOutput(true);
            connection.setInstanceFollowRedirects(true);
            connection.setUseCaches(false);
            connection.setRequestMethod(firstLine[0]);
            if(connection instanceof HttpsURLConnection) {
               SSLContext code = SSLContext.getInstance("SSL");
               code.init((KeyManager[])null, new TrustManager[]{new X509TrustManager() {
                  public void checkClientTrusted(X509Certificate[] arg0, String arg1) throws CertificateException {
                  }
                  public void checkServerTrusted(X509Certificate[] arg0, String arg1) throws CertificateException {
                  }
                  public X509Certificate[] getAcceptedIssuers() {
                     return new X509Certificate[0];
                  }
               }}, new SecureRandom());
               ((HttpsURLConnection)connection).setSSLSocketFactory(code.getSocketFactory());
               ((HttpsURLConnection)connection).setHostnameVerifier(new HostnameVerifier() {
                  public boolean verify(String arg0, SSLSession arg1) {
                     return true;
                  }
               });
            }

            int var27;
            for(var27 = 1; var27 < properties.length; ++var27) {
               if(StringUtils.isNotBlank(properties[var27])) {
                  String[] resp = properties[var27].split(": ");
                  if(resp.length == 2) {
                     connection.setRequestProperty(resp[0], resp[1]);
                  }
               }
            }

            try {
               connection.connect();
            } catch (Exception var25) {
               throw new UEException("网站连接失败", var25);
            }

            if(StringUtils.isNotBlank(reqBody)) {
               os = connection.getOutputStream();
               os.write(reqBody.getBytes());
               os.flush();
            }

            try {
               var27 = connection.getResponseCode();
            } catch (Exception var24) {
               throw new UEException("网站响应超时", var24);
            }

            StringBuffer var28 = new StringBuffer();
            Map map = connection.getHeaderFields();
            Iterator var14 = map.entrySet().iterator();

            while(var14.hasNext()) {
               Entry entry = (Entry)var14.next();
               String key = (String)entry.getKey();
               List values = (List)entry.getValue();
               if(key != null || values != null && values.size() > 0) {
                  var28.append("\r\n");
                  if(key != null) {
                     var28.append(key);
                     var28.append(": ");
                  }

                  if(values != null && values.size() > 0) {
                     var28.append((String)values.get(0));
                  }
               }
            }

            var28.append("\r\n\r\n");

            try {
               var28.append(IOUtils.toString(var27 == 200?connection.getInputStream():connection.getErrorStream(), charset == null?"utf8":charset));
            } catch (Exception var23) {
               ;
            }

            var18 = var28.toString();
         } finally {
            IOUtils.closeQuietly(os);
            connection.disconnect();
         }

         return var18;
      } else {
         return "";
      }
   }

   public static void main(String[] args) throws Exception {
      String s = "GET / HTTP/1.1\nHost: www.qq.com\nUser-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729; LCJB; rv:11.0) like Gecko\nAccept: */*\nCookie: websitez_mobile_detector=%7C0%7Ca13660536cf946d6a657435bc5239150; PHPSESSID=n225pj9li5qfsnl7u4d3takmr5\nConnection: Keep-alive\nContent-Length: 55\nContent-Type: application/x-www-form-urlencoded\n";
      System.out.println(requestByData("www.qq.com", s, (String)null, (String)null));
   }
}
